# include <stdio.h>
# include <stdlib.h>
# include <time.h>
# include <math.h>
# include "ApEn.h"

//ڴ浥Ԫ:ڼmά
float ApEn_MD_Buff[APEN_MD_LEN][APEN_DIMENSION_M];
//ڴ浥Ԫ:ڼm+1ά
float ApEn_M1D_Buff[APEN_M1D_LEN][APEN_DIMENSION_M1];
//ڴ浥Ԫ:mάȵľ
float ApEn_DsitanceAll_m[APEN_MD_LEN];
//ڴ浥Ԫ:m+1άȵľ
float ApEn_DsitanceAll_m1[APEN_M1D_LEN]; 

//׼ 
float ApEn_StdVal = 0;
//: ׼
float ApEn_StdProp = 0.2;
//: ֵ
float ApEn_Threshold = 0;
//mάƽֵ
float ApEn_DistLnAVR_m = 0; 
//m+1άƽֵ
float ApEn_DistLnAVR_m1 = 0;
//
float ApEn_Result = 0; 



//ûAPIӿں
float ApEn_Calculate(float Prop, float* buff)
{
	//ʼ㷨 
	ApEn_Algorithm_Init(Prop, buff); 
	//ع 
	ApEn_Restructure(buff, APEN_DATA_LEN);
	//
	ApEn_Calculate_All_Distance();
	//ƽֵ 
	ApEn_Calculate_ln_AVR();
	//ó 
	ApEn_Sub_Result();
	//ؽ 
	return ApEn_Result;
}

//û: ʼ㷨
void ApEn_Algorithm_Init(float Prop, float* buff)
{
	//ֵ 
	ApEn_StdProp = Prop;
	//׼ 
	ApEn_StdVal = ApEn_STD_Deviation(buff, APEN_DATA_LEN);	
	//ֵ
	ApEn_Threshold = ApEn_StdVal * Prop;
}


//ߺ׼ 
float ApEn_STD_Deviation(float* buff, unsigned int len)
{
	unsigned int i = 0;
	//ܺ 
	float sum = 0;
	//ƽֵ
	float avr = 0;
	//ʱ
	float temp = 0;
	//׼
	float std; 
	//ܺ 
	for(i = 0; i < len; ++i){
		sum += buff[i];		
	}
	//ݵƽֵ
	avr = sum / (float)len;
	//㷽
	sum = 0;
	for(i = 0; i < len; ++i){
		//ÿԪؼȥƽֵ,ƽ 
		temp = 	(buff[i] - avr) * (buff[i] - avr); 	
		//ܺ
		sum += temp; 
	}
	//㷽 
	avr = sum/len;
	//׼ 
	std = sqrt(avr);
	//ر׼ 
	return std;
}

//ߺع
void ApEn_Restructure(float* buff, unsigned int len)
{
	unsigned int i = 0;
	unsigned int j = 0;
	//عΪmά,һn-m+1mά 
	for(i = 0; i < (len - APEN_DIMENSION_M + 1); ++i){
		//ÿΪi,i+1,...,i+m-1
		//jiʼ,i+m-1,һȡm 
		for(j = i; j < ((i + APEN_DIMENSION_M + 1) - 1); ++j){
			ApEn_MD_Buff[i][j-i] = buff[j];				
		}	
	}
	//عΪm+1ά
	for(i = 0; i < (len - APEN_DIMENSION_M1 + 1); ++i){
		//ÿΪi,i+1,...,i+m-1
		//jiʼ,i+m-1,һȡm 
		for(j = i; j < ((i + APEN_DIMENSION_M1 + 1) - 1); ++j){
			ApEn_M1D_Buff[i][j-i] = buff[j];				
		}	
	}
}

//ߺ: mά(VecΪһά,mΪά)
float ApEn_Calculate_Distance(float* Vec1, float* Vec2, unsigned int m)
{
	unsigned int i = 0, j = 0;
	float element = 0, elementMax = 0;
	//ÿӦԪصĲֵ,ȡֵ 
	for(i = 0; i < m; ++i){
			//Ĳ 
			element = Vec1[i] - Vec2[i];	
			//ֵ
			element = fabs(element);
			//ֵ,͸ֵֵ 
			if(element > elementMax){
				elementMax = element;
			}
	}
	//صֵΪ 
	return elementMax;
}


double Test_Buff[500];
//ߺ
void ApEn_Calculate_All_Distance(void)
{
	unsigned int i = 0, j = 0, Cnt = 0;
	double Distance = 0; 
	//mάľ
	for(i = 0; i < APEN_MD_LEN; ++i){
		// 
		Cnt = 0;
		for(j = 0; j < APEN_MD_LEN; ++j){
			// 
			Distance = ApEn_Calculate_Distance(ApEn_MD_Buff[i], ApEn_MD_Buff[j], APEN_DIMENSION_M);
			//Сڵ趨ֵ
			if(Distance <= ApEn_Threshold){
				++Cnt;	
			}
		}
		ApEn_DsitanceAll_m[i] = (float)Cnt/(float)APEN_MD_LEN;		
	}
	//m+1άľ
	for(i = 0; i < APEN_M1D_LEN; ++i){
		// 
		Cnt = 0;
		for(j = 0; j < APEN_M1D_LEN; ++j){
			// 
			Distance = ApEn_Calculate_Distance(ApEn_M1D_Buff[i], ApEn_M1D_Buff[j], APEN_DIMENSION_M1);
			//Сڵ趨ֵ
			if(Distance <= ApEn_Threshold){
				++Cnt;	
			}
		}
		ApEn_DsitanceAll_m1[i] = (float)Cnt/(float)APEN_M1D_LEN;		
	}
}

//ߺƽֵ
void ApEn_Calculate_ln_AVR(void)
{
	unsigned int i = 0;
	float Logar = 0, sum = 0;
	//Ծƽֵ 
	for(i = 0; i < APEN_MD_LEN; ++i){
		//ln 
		Logar = logf(ApEn_DsitanceAll_m[i]);
		// 
		sum += Logar;		
	}
	//ƽֵ 
	ApEn_DistLnAVR_m = sum / APEN_MD_LEN;
	//Ծƽֵ 
	sum = 0;
	for(i = 0; i < APEN_M1D_LEN; ++i){
		//ln 
		Logar = logf(ApEn_DsitanceAll_m1[i]);
		// 
		sum += Logar;		
	}
	//ƽֵ 
	ApEn_DistLnAVR_m1 = sum / APEN_M1D_LEN;
}

//ߺƽֵ
void ApEn_Sub_Result(void)
{
	ApEn_Result = fabs(ApEn_DistLnAVR_m - ApEn_DistLnAVR_m1);
}














